<?php
/**
 * Plugin Name: Gecko Blocks
 * Description: Blocks by Gecko Designs, made with <3 in MT
 * Version: 1.2.2
 * Author: Gecko Designs
 * Author URI: https://geckodesigns.com
 * Text Domain: gecko-designs
 * License: GPLv2 or later
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
define( 'GECKO_BLOCKS__FILE', __FILE__);
define( 'GECKO_BLOCKS__PLUGIN_URL', plugin_dir_url( __FILE__ ) );
define( 'GECKO_BLOCKS__PLUGIN_DIR', plugin_dir_path( __FILE__ ) );

/*
 * Class AutoLoader
 * This is the one of the most important features of gecko command
 * It creates the naming convention for gecko plugins
 */
spl_autoload_register(function( $class) {
	$namespaces = explode('\\', $class);
	// Registering Additional Plugins Schema
	if(in_array('GeckoBlocks', $namespaces)){
		foreach ($namespaces as $namespace) {
			$file = $namespace;
		}
		array_shift($namespaces);
		$index = count( $namespaces ) - 1;
		$value = $namespaces[$index];
		$namespaces[$index] = 'class-'.$value.'.php';
		$path = strtolower(preg_replace('/([a-zA-Z])(?=[A-Z])/', '$1-', implode('/',$namespaces)));
		// $class_file = GECKO_BLOCKS__PLUGIN_DIR . 'includes/class-'. strtolower(preg_replace('/([a-zA-Z])(?=[A-Z])/', '$1-', $file))  . '.php';
		$class_file = GECKO_BLOCKS__PLUGIN_DIR . 'includes/'.$path;
		if(file_exists($class_file)){
			require_once $class_file;
		}
	}
});

/*
 * Initiate
 */
function GECKO_BLOCKS(){return;}
add_action( 'plugins_loaded', function(){
	new GeckoBlocks\Init();
} );
